/////////////////////////////////////////////////////////////////////////////////////////
//Die Klasse Complex liefert die wichtigsten Rechnung auf dem Körper der komplexen Zahlen
//////////////////////////////////////////////////////////////////////////////////////////
class Complex {
  
    double re;//Realteil
    double im;//Imaginärteil
 
   //0 erstellen
    public Complex() {
        this(0);
    }
    //reele Zahl erstellen
    public Complex(double real) {
        this(real, 0);
    }
 
   //komplexe Zahl erstellen
    public Complex(double real, double img) {
        this.re = real;
        this.im = img;
    }
 
   //komplexe Zahl aus anderer kompl. Zahl erstellen
    public Complex(Complex c2) {
        this.re = c2.re;
        this.im = c2.im;
    }
   
    //komplexe Zahl zu gegebener kompl Zahl addieren
    public Complex addC(Complex c2) {
        return new Complex(this.re + c2.re, this.im + c2.im);
    }
 
    //komplexe Zahl von gegebener kompl Zahl subrahieren
    public Complex subtractC(Complex c2) {
        return new Complex(this.re - c2.re, this.im - c2.im);
    }
 
    //komplexe Zahl mit gegebener Zahl multiplizieren
    public Complex multiply(Complex c2) {
        double re = this.re * c2.re - this.im * c2.im;
        double im = this.im * c2.re + this.re * c2.im;
        return new Complex(re, im);
    }
 
   //komplexe Zahl durch gegebener Zahl dividieren
    public Complex divide(Complex c2) {
        double cAndDSquared = (c2.re * c2.re + c2.im * c2.im);
        double re = (this.re * c2.re + this.im * c2.im) / cAndDSquared;
        double im = (this.im * c2.re - this.re * c2.im) / cAndDSquared;
        return new Complex(re, im);
    }
    
    //Quadratwurzel aus komplexer Zahl
    public Complex sqrtC() {
       double r = this.getLength();
       double x = this.getRealPart()/r;//cos(w1)
       double y = this.getImaginaryPart()/r;//sin(w2)
       double w1 = Math.acos(x);
       double w2 = Math.asin(y);
       
       if(x<0 && y<0){
          w1 = 2*Math.PI-w1;
          w2 = Math.PI-w2;    
       }
       if(x<0 && y>0){
          w2 = Math.PI-w2;
       }
      
      return new Complex(Math.sqrt(r)*Math.cos(w1/2),Math.sqrt(r)*Math.sin(w2/2));
    }
    
    public Complex logC(){
       double r = this.getLength();
       double x = this.getRealPart()/r;//cos(w1)
       double y = this.getImaginaryPart()/r;//sin(w2)
       double w1 = Math.acos(x);
       double w2 = Math.asin(y);
        if(x<0 && y<0){
          w1 = 2*Math.PI-w1;
          w2 = Math.PI-w2;    
       }
       if(x<0 && y>0){
          w2 = Math.PI-w2;
       }  
       if(w2 >  Math.PI) w2 = w2 -2*Math.PI;
       if(w2 < -Math.PI) w2 = w2 +2*Math.PI;
     
       Complex ergebnis = new Complex(log((float)r),w2) ;
      
       return ergebnis;
    }
   
    
    //sinus einer komplexen Zahl
    public Complex sinC() {
      Complex i = new Complex(0,1);
      Complex e = new Complex(Math.exp(1),0);
      Complex zEP = new Complex(0,0);
      Complex zEN = new Complex(0,0);
      Complex zaehler = new Complex(0,0);
      Complex nenner = new Complex(0,0);
      Complex ergebnis = new Complex(0,0);
      zEP = this.multiply(i);
      zEP = e.power(zEP);
      zEN = this.multiply(i).multiply(-1);;
      zEN = e.power(zEN);
      zaehler = zEP.subtractC(zEN);
      nenner = i.multiply(2);
      ergebnis = zaehler.divide(nenner);
      return ergebnis;      
    }
    
     //cosinud einer komplexen Zahl
     public Complex cosC() {
      Complex i = new Complex(0,1);
      Complex e = new Complex(Math.exp(1),0);
      Complex zEP = new Complex(0,0);
      Complex zEN = new Complex(0,0);
      Complex zaehler = new Complex(0,0);
     // Complex nenner = new Complex(0,0);
      Complex ergebnis = new Complex(0,0);
      zEP = this.multiply(i);
      zEP = e.power(zEP);
      zEN = this.multiply(i).multiply(-1);;
      zEN = e.power(zEN);
      zaehler = zEP.addC(zEN);
      //nenner = i.multiply(2);
      ergebnis = zaehler.divide(2);
      return ergebnis;      
    }
    
    
    //reziproke komplexe Zahl bestimmen
    public Complex reciproc(){
      Complex eins = new Complex();
      eins.re =1; eins.im =0;
      return eins.divide(this);
      
    }
    
    //Betrag einer komplexen Zahl betimmen
    public double getLength(){
      
       return laenge = Math.sqrt(this.re*this.re+this.im*this.im);         
    }
    
     //Winkel (positiv) im Bogenmaß bestimmen
     public double getAngle(){
        double winkel,rT,iT;
        iT = this.getImaginaryPart();
        rT = this.getRealPart();
        winkel = Math.atan(iT/rT);
        if(rT < 0 && iT > 0) winkel =  Math.PI + winkel;
        if(rT < 0 && iT < 0) winkel =  Math.PI +winkel;
        if(rT > 0 && iT < 0) winkel = 2*Math.PI +winkel;
        return winkel;
    }
   
    //komplexe Zahl potenzieren
    public Complex power(int potenz){
      Complex z = new Complex();
      z = this;
      for(int i =1; i<potenz;i++){
         z = this.multiply(z);
      } 
      return z; 
    }
    
    public Complex power(Complex p){
      Complex ergebnis ;
      double rZ, iZ, rP, iP, a, D, l, r ;
      l = this.getLength();
      rZ = this.getRealPart();iZ = this.getImaginaryPart();
      rP = p.getRealPart();iP = p.getImaginaryPart();
      a= Math.atan(iZ/rZ);
      if(iZ<0 && rZ<0) a = a-Math.PI;
      if(iZ>0 && rZ<0) a = a+Math.PI;
      
      D= rP*a + iP*Math.log(l);
      
      r= Math.pow(l,rP)*Math.exp(-iP*a);
      ergebnis = new Complex(r*Math.cos(D),r*Math.sin(D)); 
      
      return ergebnis;
    }
    
    //komplexe Zahl negieren
    public Complex negate(){
      double re = -this.re;
      double im = -this.im;
      return new Complex(re, im);
    }
 
    //komplexe Zahl zu reeller Zahl addieren
    public Complex addC(double number) {
        return this.addC(new Complex(number));
    }
 
    //von komplexer Zahl reelle Zahl subtrahieren
    public Complex subtract(double number) {
        return this.subtractC(new Complex(number));
    }
 
   //komplexe Zahl mit reeller Zahl multiplizieren
    public Complex multiply(double number) {
        return this.multiply(new Complex(number));
    }
 
   //komplexe Zahl durch reele Zahl dividieren
    public Complex divide(double number) {
        return this.divide(new Complex(number));
    }
    
 
    public void setRealPart(double real) {
        this.re = real;
    }
 
    public double getRealPart() {
        return this.re;
    }
 
    public void setImaginaryPart(double imaginary) {
        this.im = imaginary;
    }
 
    public double getImaginaryPart() {
        return this.im;
    }
 
    public Complex clone() {
        return new Complex(this.re, this.im);
    }
 
    public boolean equals(Object o) {
        if (o instanceof Complex) {
            Complex c2 = (Complex) o;
            if (c2.re == this.re && c2.im == this.im) {
                return true;
            }
        }
        return false;
    }
 
    public int hashCode() {
        Double re = this.re;
        Double im = this.im;
 
        // XOR erhält eine Gleichverteilung
        return re.hashCode() ^ im.hashCode();
    }
 
    public String toString() {
        return this.re + "+" + this.im + "i";
    }
}
